#!/bin/sh
# This code was taken from http://biolpc22.york.ac.uk/pub/linux-mac-cross/,
# written by Mike Wetherell and prettied up a little by Johannes Schindelin
# and Ron Burkey.  Its purpose is to use a Linux workstation to extract the 
# SDK from the Apple Xcode .dmg image which you can download from 
# http://developer.apple.com if you've set up an account there, in order to
# allow installation of cross-compilation tools using the IMCROSS project
# (http://www.sandroid.org/imcross/index.html).

	#########################################################
	# There is no guarantee whatever that this script	#
	# will work for you.  The only guaranteed way to 	#
	# extract the SDK is to open the .dmg on a Mac,		#
	# and to extract it there.  You SHOULD be able to do    #
	# that, since the purpose of the SDK is to allow you to #
	# develop code for the Mac, and if you don't have a Mac #
	# then you'll have no way to test the programs you are  #
	# developing anyway!					#
	#########################################################

# Default names for Xcode .dmg file and SDK to extract.
XCODE=xcode25_8m2558_developerdvd.dmg
SDK=MacOSX10.4u.sdk

# Replace the default names by names from the command line, if any.
test -z "$1" || XCODE="$1"
test -z "$2" || SDK="$2"

# Step 1:  Try mounting the .dmg as a filesystem.  You need root
# permissions with 'sudo' for this.  This method is theoretically
# supposed to work, but fails on every Linux version for which I've
# tried it.




# Step 2:  If that didn't work, try scanning the file to find just
# the chunk of it that we need.  If the chunk isn't congiguous this
# will fail.

od -t x1 $XCODE |
grep '^[0-7]*000 1f 8b' > offsets.txt &&
awk '{ print $1 }' offsets.txt |
while read x
do
        dd if=$XCODE skip=$((0$x/512)) count=1 |
        gunzip  |
        cpio -t |
        grep -q $SDK &&
        echo $((0$x/512))
done > offsets2.txt
for offset in $(cat offsets2.txt)
do
        dd if=$XCODE skip=$offset |
        gunzip |
        pax -r
done


# Step 3:  Convert the extracted output into a form acceptable to IMCROSS.


# Step 4:  Clean up the mess.

