/*
  Filename:	bzero.c
  Author:	Ron Burkey
  Legal:	I, Ron Burkey, am placing this file in the public domain.
  Purpose:     	A program that simply zeroes out a range of addresses in a
  		file.
  Mod history:	2008-05-11 RSB	Created.
*/

#include <stdio.h>

int
main (int argc, char *argv[])
{
  FILE *fp;
  int Address, Start, End, i, j;
  
  if (argc < 4)
    {
      printf ("Syntax:  bzero HexStart HexEnd File1 [File2 [File3 ...]]\n");
      return (1);
    }

  if (1 != sscanf (argv[1], "%X", &Start))
    {
      printf ("Start address not valid.\n");
      return (1);
    }
  if (1 != sscanf (argv[2], "%X", &End))
    {
      printf ("End address not valid.\n");
      return (1);
    }

  for (i = 3; i < argc; i++)
    {
    
      fp = fopen (argv[i], "r+");
      if (fp == NULL)
	{
	  printf ("File %s does not exist.\n", argv[i]);
	  return (1);
	}
	
      fseek (fp, Start, SEEK_SET);
      for (j = Start; j < End; j++)
        fputc (0, fp);	
	
      fclose (fp);
    }

  return (0);
}

